/*
 *  Lorawan Ewattch Javascript Decoder v1.1.7
 *  Date : 2023-05-28
 *  Author: Guillaume Caruso, Ewattch
 *
 *
 *  Decoder for Ewattch Lorawan Products, written in javascript
 *
 *
 *  BSD 3-Clause License
 *
 *  Copyright (c) 2021, Ewattch
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice, this
 *     list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright notice,
 *     this list of conditions and the following disclaimer in the documentation
 *     and/or other materials provided with the distribution.
 *
 *  3. Neither the name of the copyright holder nor the names of its
 *     contributors may be used to endorse or promote products derived from
 *     this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 *  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 *  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
function signed16(e){return 32768&e&&(e-=65536),e}function signed8(e){return 128&e&&(e-=256),e}function float(e){var t,a=0===(a=(2139095040&e)>>23)?(t=!0,-149):(t=!1,a-127-23),r=8388607&e;return!1===t&&(r|=8388608),2147483648&e?-Math.pow(2,a)*r:Math.pow(2,a)*r}function decodeUplink(e){return LoraWANEwattchDecoder(e.bytes,e.fPort,!0)}String.prototype.padStart||(String.prototype.padStart=function(e,t){return e>>=0,t=String(void 0!==t?t:" "),this.length>e?String(this):((e-=this.length)>t.length&&(t+=t.repeat(e/t.length)),t.slice(0,e)+String(this))}),LoraWANEwattchDecoder=function(e,t,a){var r={"00":"environnement","01":"presence","02":"ambiance","08":"squid",10:"impulse",20:"tyness",28:"tynode"},h={"00":[2,function(e,t,a){return{uuid:"temperature_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"temperature",value:signed16(e[0]|e[1]<<8)/100,unit:"°C"}},function(e,t){return"temperature_s"+e+"_c"+t}],"04":[1,function(e,t,a){return{uuid:"humidity_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"humidity",value:e[0]/2,unit:"%RH"}},function(e,t){return"humidity_s"+e+"_c"+t}],"08":[2,function(e,t,a){return{uuid:"C02_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"co2",value:e[0]|e[1]<<8,unit:"ppm"}},function(e,t){return"C02_s"+e+"_c"+t}],"0C":[2,function(e,t,a){return{uuid:"counter_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"counter",value:e[0]|e[1]<<8,unit:""}},function(e,t){return"counter_s"+e+"_c"+t}],"0E":[3,function(e,t,a){return{uuid:"time_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"time",value:e[0]|e[1]<<8|e[2]<<16,unit:"s"}},function(e,t){return"time_s"+e+"_c"+t}],10:[2,function(e,t,a){return{uuid:"luminosity_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"luminosity",value:e[0]|e[1]<<8,unit:"lx"}},function(e,t){return"luminosity_s"+e+"_c"+t}],14:[2,function(e,t,a){return{uuid:"motion_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"motion",value:10*(e[0]|e[1]<<8),unit:"s"}},function(e,t){return"motion_s"+e+"_c"+t}],16:[2,function(e,t,a){return{uuid:"pressure_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"pressure",value:signed16(e[0]|e[1]<<8)/100,unit:"barg"}},function(e,t){return"pressure_s"+e+"_c"+t}],18:[2,function(e,t,a){return{uuid:"flow_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"flow",value:(e[0]|e[1]<<8)/100,unit:"m3/h"}},function(e,t){return"flow_s"+e+"_c"+t}],"1A":[2,function(e,t,a){return{uuid:"volume_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"volume",value:e[0]|e[1]<<8,unit:"m3"}},function(e,t){return"volume_s"+e+"_c"+t}],"1C":[4,function(e,t,a){return{uuid:"volume_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"volume",value:float(e[0]|e[1]<<8|e[2]<<16|e[3]<<24),unit:"m3"}},function(e,t){return"volume_s"+e+"_c"+t}],20:[1,function(e,t,a){return n(e,t,a,1)},function(e,t){return"digital_input_s"+e+"_c"+t}],22:[1,function(e,t,a){return n(e,t,a,2)},function(e,t){return"digital_input_s"+e+"_c"+t}],24:[1,function(e,t,a){return n(e,t,a,4)},function(e,t){return"digital_input_s"+e+"_c"+t}],26:[1,function(e,t,a){return n(e,t,a,8)},function(e,t){return"digital_input_s"+e+"_c"+t}],28:[3,function(e,t,a){var r,n,u;r=(224&e[0])>>5?.001:.01;0==(31&e[0])?(n="mA",u="4:20"):1==(31&e[0])?(n="V",u="0:10"):2==(31&e[0])&&(n="V",u="0:24");return{uuid:"analog_input_s"+t+"_c"+a,hardwareData:{socket:t,channel:a,scale:u},type:"analogInput",value:signed16(e[1]|e[2]<<8)*r,unit:n}},function(e,t){return"analog_input_s"+e+"_c"+t}],40:[0,function(e,t,a){var r=0,n=(240&e[r])>>4,u=15&e[r],i=[];switch(r++,u){case 0:for(var c=0;c<n;c++)i.push({type:"currentIndex",hardwareData:{socket:t,channel:a+c},uuid:"clamp_s"+t+"_c"+(a+c),value:10*(e[r]|e[r+1]<<8|e[r+2]<<16),unit:"mAh"}),r+=3;break;case 1:for(c=0;c<n;c++)i.push({type:"current",hardwareData:{socket:t,channel:a+c},uuid:"clamp_s"+t+"_c"+(a+c),value:e[r]|e[r+1]<<8|e[r+2]<<16,unit:"mA"}),r+=3;break;case 2:for(c=0;c<n;c++)i.push({type:"currentIndex",hardwareData:{socket:t,channel:a+c},uuid:"clamp_s"+t+"_c"+(a+c),value:10*(e[r]|e[r+1]<<8|e[r+2]<<16),unit:"mAh"}),r+=3;for(c=0;c<n;c++)i.push({type:"current",hardwareData:{socket:t,channel:a+c},uuid:"clamp_s"+t+"_c"+(a+c),value:e[r]|e[r+1]<<8|e[r+2]<<16,unit:"mA"}),r+=3;break;default:var s={3:["consumedActiveEnergyIndex",10,"Wh"],4:["power",1,"W"],5:["producedActiveEnergyIndex",10,"Wh"],6:["positiveReactiveEnergyIndex",10,"varh"],7:["negativeReactiveEnergyIndex",10,"varh"],8:["reactivePower",1,"var"],9:["apparentEnergyIndex",10,"VAh"],10:["voltage",.1,"V"],11:["apparentPower",1,"VA"],12:["frequency",.01,"hZ"]}[u.toString()];if(null==s)return"No such measure code";for(var o=10===u||12===u?2:3,c=0;c<n;c++)i.push({type:s[0],hardwareData:{socket:t,channel:a+c},uuid:"clamp_s"+t+"_c"+(a+c),value:(2==o?e[r]|e[r+1]<<8:e[r]|e[r+1]<<8|e[r+2]<<16)*s[1],unit:s[2]}),r+=o}return e.splice(0,r),i},function(e,t){return"clamp_s"+e+"_c"+t}],44:[4,function(e,t,a){return{uuid:"active_energy_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"activeEnergyIndex",value:e[0]|e[1]<<8|e[2]<<16|e[3]<<24,unit:"kWh"}},function(e,t){return"active_energy_s"+e+"_c"+t}],46:[4,function(e,t,a){return{uuid:"reactive_energy_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"reactiveEnergyIndex",value:e[0]|e[1]<<8|e[2]<<16|e[3]<<24,unit:"kvarh"}},function(e,t){return"reactive_energy_s"+e+"_c"+t}],48:[0,function(e,t,a){for(var r=0,n=[],u=0;u<12;u++)n.push({type:"currentIndex",hardwareData:{socket:t,channel:a+u},uuid:"clamp_s"+t+"_c"+(a+u),value:10*(e[r]|e[r+1]<<8|e[r+2]<<16),unit:"mAh"}),r+=3;return e.splice(0,r),n},function(e,t){return"clamp_s"+e+"_c"+t}],50:[0,function(e,t,a){var r=0,n={uuid:"tic_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"tic",values:[],metadata:{}},a=e[r];r++;var u,i=0,c=0;15==(15&a)||14==(15&a)||0===a?(n.metadata.counterError=l[a.toString(16).toUpperCase().padStart(2,"0")]||"error code 0x"+a.toString(16).padStart(2,"0"),e.splice(0,r)):n.metadata.counterType=l[a.toString(16).toUpperCase().padStart(2,"0")];var s,o=[];switch(a){case 16:switch(n.metadata.checksum=e[1],u=e[2],i=(224&u)>>5&7,c=31&u,n.metadata.subscription=p[i.toString(16).toUpperCase().padStart(2,"0")],n.metadata.tarrifPeriod=m[c.toString(16).toUpperCase().padStart(2,"0")],r+=2,i){case 0:o=["Base"];break;case 1:o=["HC","HP"];break;case 2:o=["Heures Normales","Heures Pointe mobile"];break;case 3:o=["HC Jour bleu","HC Jour blanc","HC Jour rouge","HP Jour bleu","HP Jour blanc","HP Jour rouge"]}for(var d=0;d<o.length;d++)s=o[d],n.values.push({type:s,value:e[r]|e[r+1]<<8|e[r+2]<<16|e[r+3]<<24,unit:"Wh"}),r+=4;break;case 32:u=e[r],i=(240&u)>>4&15,c=15&u,n.metadata.subscription=_[i.toString(16).toUpperCase().padStart(2,"0")],n.metadata.tarrifPeriod=f[c.toString(16).toUpperCase().padStart(2,"0")],r++,o=["1","2","3","4"];for(d=0;d<o.length;d++)s=o[d],n.values.push({value:e[r]|e[r+1]<<8|e[r+2]<<16,unit:"kWh"}),r+=3;break;case 48:i=e[r],n.metadata.subscription=g[i.toString(16).toUpperCase().padStart(2,"0")],c=e[++r],n.metadata.tarrifPeriod=P[c.toString(16).toUpperCase().padStart(2,"0")],r++,o=["ActiveEnergyCurrentPeriode","PositiveReactiveEnergyCurrentPeriode","NegativeReactiveEnergyCurrentPeriode","ActiveEnergyPreviousPeriode","PositiveReactiveEnergyPreviousPeriode","NegativeReactiveEnergyPreviousPeriode"];for(d=0;d<o.length;d++)s=o[d],n.values.push({type:s,value:e[r]|e[r+1]<<8|e[r+2]<<16,unit:d%3==0?"kWh":"kVarh"}),r+=3;break;case 64:switch(i=e[r],n.metadata.subscription=y[i.toString(16).toUpperCase().padStart(2,"0")],c=e[++r],n.metadata.tarrifPeriod=H[c.toString(16).toUpperCase().padStart(2,"0")],r++,n.values.activePower10Minutes={value:e[r]|e[r+1]<<8,unit:"kW"},r+=2,n.values.reactivePower10Minutes={value:e[r]|e[r+1]<<8,unit:"kVar"},r+=2,i){case 10:o=["P","HPH","HCH","HPE","HCE"];break;case 11:o=["P","HPH","HCH","HPD","HCD","HPE","HCE","JA"];break;case 16:o=["PM","HH","HPE","HCE"];break;case 17:o=["PM","HH","HD","HPE","HCE","JA"];break;case 18:o=["PM","HM","DSM","SCM"]}for(d=0;d<o.length;d++)s=o[d],n.values.push({type:s,value:e[r]|e[r+1]<<8|e[r+2]<<16,unit:"kWh"}),r+=3;break;case 80:n.metadata.checksum=e[r],c=e[++r],n.metadata.tarrifPeriod=31&c,r++,n.values.push({value:e[r]|e[r+1]<<8|e[r+2]<<16|e[r+3]<<24,unit:"Wh"}),r+=4;break;case 81:n.metadata.checksum=e[r],c=e[++r],n.metadata.tarrifPeriod=31&c,r++,n.values.push({value:e[r]|e[r+1]<<8|e[r+2]<<16|e[r+3]<<24,unit:"Wh"}),r+=4,n.values.push({value:e[r]|e[r+1]<<8|e[r+2]<<16|e[r+3]<<24,unit:"Wh"}),r+=4;break;case 96:n.metadata.checksum=e[r],r++,n.metadata.tarrifPeriod=String.fromCharCode(e[r])+String.fromCharCode(e[r+1])+String.fromCharCode(e[r+2]),r+=3,n.values.push({type:"tgphis",value:signed16(e[r]|e[r+1]<<8)/100,unit:""}),r+=2,o=["1","2","3","4","5","6","7","8"];for(d=0;d<o.length;d++)s=o[d],n.values.push({value:e[r]|e[r+1]<<8|e[r+2]<<16|e[r+3]<<24,unit:"Wh"}),r+=4}return e.splice(0,r),n},function(e,t){return"tic_s"+e+"_c"+t}],58:[0,function(e,t,a){var r=0,n={uuid:"mbus_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"mbus",values:[],metadata:{}},a=e[r],u=(240&e[++r])>>4,i=15&e[r];switch(u){case 0:n.metadata.device_name="HEAT METER";break;case 1:n.metadata.device_name="WATER METER";break;case 2:n.metadata.device_name="ELECTRICITY METER";break;case 3:n.metadata.device_name="GAZ METER";break;default:return e.splice(0,r),n.metadata.error="Unkwown meter code 0x"+u.toString(16),n}n.metadata.device_slave_adress=a,r++,e.splice(0,r);var c=0;for(;0<e.length&&c<i;){var s=1&e[0],o=(254&e[0]).toString(16).toUpperCase().padStart(2,"00"),d=h[o];if(null==d)return n.metadata.error="Unkwown object type 0x"+o.toString(16),n;e.splice(0,1);var l=0,o=0;s&&(l=(224&e[0])>>5,o=31&e[0],e.splice(0,1)),o=d[1](e,l,o),Array.isArray(o)?n.values=n.values.concat(o):n.values.push(o),e.splice(0,d[0]),c++}return n},function(e,t){return"mbus_s"+e+"_c"+t}],"5C":[0,function(e,t,a){var r=0,n={uuid:"modbus_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"modbus",values:[],metadata:{}},a=e[++r];n.metadata.application_code=63&a,n.metadata.standardised=(64&a)>>7==1;var u=e[++r];switch(u){case 3:n.metadata.command="Read Holding Registers";break;case 4:n.metadata.command="Read Input Registers";break;case 8:n.metadata.command="Read Diagnostics";break;case 16:n.metadata.command="Write Multiples Registers Response";break;case 80:n.metadata.command="Master Write Multiples Registers Response";break;default:n.metadata.command="Unknown command : "+(127&u)}if(r++,3===u||4===u){n.metadata.startAdress=(e[r+1]<<8)+e[r],r+=2,n.metadata.wordCount=e[r]/2,r++;for(var i=[],c=0;c<n.metadata.wordCount&&!(r+1>e.length);)i.push((e[r+1]<<8)+e[r]),r+=2,c++;n.values=i}return e.splice(0,r),n},function(e,t){return"modbus_s"+e+"_c"+t}],74:[1,function(e,t,a){return{uuid:"battery_s"+t+"_c"+a,hardwareData:{socket:t,channel:a},type:"battery",value:e,unit:""}},function(e,t){return"battery_s"+e+"_c"+t}]},v={"00":[1,function(e,t,a){return{value:r[e[0].toString(16).toUpperCase().padStart(2,"00")],type:"nodeType"}}],"02":[2,function(e,t,a){return{value:e[1]+"."+e[0],type:"version"}}],"04":[1,function(e,t,a){return{value:e[0],type:"batteryLevel"}}],"08":[2,function(e,t,a){return{value:10*(e[0]|e[1]<<8),type:"periodicity"}}]};function n(e,t,a,r){for(var n=[],u=e[0],i=0;i<r;i++)n.push({uuid:"digital_input_s"+t+"_c"+(a+i),hardwareData:{socket:t,channel:a+i},type:"boolean",value:1&u,unit:""}),u>>=1;return e.splice(0,2),n}this.decode=function(e,t,a){if("string"==typeof e){for(var r=[],n=0,u=e.length;n<u;n+=2)r.push(parseInt(e.substr(n,2),16));e=r}var i=0,c=[];if(a=null==a?!0:a){i=0===e[0]?0:1;if(e[1]!==e.length-2)return c.push({type:"error",value:"Payload size indicated does not match payload size given"}),{data:c};e.splice(0,2)}for(;0<e.length;){var s,o=1&e[0],d=128==(128&e[0]),l=(126&e[0]).toString(16).toUpperCase().padStart(2,"00");if(null==(s=(0===i?h:v)[l]))return c.push({type:"error",value:"unknown object type : "+l}),{data:c};e.splice(0,1);var p=0,l=0;0===i&&o&&(p=(224&e[0])>>5,l=31&e[0],e.splice(0,1)),d?(c.push({uuid:s[2](p,l),hardwareData:{socket:p,channel:l},type:"error"}),e.splice(0,1)):(l=s[1](e,p,l),Array.isArray(l)?c=c.concat(l):c.push(l),e.splice(0,s[0]))}return{data:c}};var l={"0E":"Données erronées","0F":"Compteur Inconnu",10:"Bleu","1F":"Bleu avec defaut",20:"Jaune","2F":"Jaune avec defaut",30:"PME-PMI","3F":"PME-PMI avec defaut",40:"ICE","4E":"ICE V2.4","4F":"ICE avec defaut",50:"Linky",51:"Linky Injection","5F":"Linky avec defaut",60:"Saphir","6F":"Saphir avec defaut"},p={"00":"Base","01":"HP/HC","02":"EJP","03":"TEMPO"},m={"00":"Base","01":"HC","02":"HP","03":"EJP heures normales","04":"EJP heures de pointe mobile","05":"TEMPO HC Jour Bleu","06":"TEMPO HC Jour Blanc","07":"TEMPO HC Jour Rouge","08":"TEMPO HP Jour Bleu","09":"TEMPO HP Jour Blanc","0a":"TEMPO HP Jour Rouge"},_={"01":"Ete","02":"Hiver","03":"Pointe mobile"},f={"01":"Heures Pleines","02":"Heures Creuses","03":"Heures de pointe","04":"Heures de pointe mobile"},g={"00":"TJ MU","01":"TJ LU","02":"TJ LU-SD","03":"TJ LU-P","04":"TJ LU-PH","05":"TJ LU-CH","06":"TJ EJP","07":"TJ EJP-SD","08":"TJ EJP-PM","09":"TJ EJP-HH","0a":"TV A5 Base","0b":"TV A8 Base","0c":"BT 4 SUP36","0d":"BT 5 SUP36","0e":"HTA 5","0f":"HTA 8"},P={"00":"P","01":"PM","02":"HH","03":"HP","04":"HC","05":"HPH","06":"HCH","07":"HPE","08":"HCE","09":"HPD","0a":"HCD","0b":"JA"},y={"0a":"TV A5 Base","0b":"TV A8 Base",10:"TV A5 EJP",11:"TV A8 EJP",12:"TV A8 MOD"},H={"00":"P","01":"PM","02":"HH","03":"HP","04":"HC","05":"HPH","06":"HCH","07":"HPE","08":"HCE","09":"HPD","0a":"HCD","0b":"JA","0c":"HD","0d":"HM","0e":"DSM","0f":"SCM"};return this.decode(e,t,a)};
